Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncCu.cpp
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncCu.cpp	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncCu.cpp	(revision 193)
@@ -1101,5 +1544,5 @@
 #endif
     {
-    rpcBestCU->getTotalCost()  = m_pcRdCost->calcRdCost( rpcBestCU->getTotalBits(), rpcBestCU->getTotalDistortion() );
+      rpcBestCU->getTotalCost()  = m_pcRdCost->calcRdCost( rpcBestCU->getTotalBits(), rpcBestCU->getTotalDistortion() );
     }
 
@@ -1125,5 +1568,5 @@
     }
 #if HHI_INTERVIEW_SKIP
-  rpcBestCU->setRenderableSubParts(bFullyRenderedSec,0,rpcBestCU->getDepth( 0 )) ;
+    rpcBestCU->setRenderableSubParts(bFullyRenderedSec,0,rpcBestCU->getDepth( 0 )) ;
 #endif
   }
@@ -1189,8 +1632,8 @@
   {
 #if LOSSLESS_CODING
-      if (isAddLowestQP && (iQP == iMinQP))
-      {
-        iQP = lowestQP;
-      }
+    if (isAddLowestQP && (iQP == iMinQP))
+    {
+      iQP = lowestQP;
+    }
 #endif
     rpcTempCU->initEstData( uiDepth, iQP );
@@ -1301,5 +1744,5 @@
 #endif
       {           
-      rpcTempCU->getTotalCost()  = m_pcRdCost->calcRdCost( rpcTempCU->getTotalBits(), rpcTempCU->getTotalDistortion() );
+        rpcTempCU->getTotalCost()  = m_pcRdCost->calcRdCost( rpcTempCU->getTotalBits(), rpcTempCU->getTotalDistortion() );
       }
 
@@ -1344,5 +1787,5 @@
 #endif
           {
-          rpcTempCU->getTotalCost()  = m_pcRdCost->calcRdCost( rpcTempCU->getTotalBits(), rpcTempCU->getTotalDistortion() );
+            rpcTempCU->getTotalCost()  = m_pcRdCost->calcRdCost( rpcTempCU->getTotalBits(), rpcTempCU->getTotalDistortion() );
           }
 #endif
@@ -1393,8 +1836,8 @@
     }                                                                                  // with sub partitioned prediction.
 #if LOSSLESS_CODING
-      if (isAddLowestQP && (iQP == lowestQP))
-      {
-        iQP = iMinQP;
-      }
+    if (isAddLowestQP && (iQP == lowestQP))
+    {
+      iQP = iMinQP;
+    }
 #endif
   } // SPLIT- QP Loop
@@ -1403,9 +1846,9 @@
   if( m_pcRdCost->getUseRenModel() )
   {
-      UInt  uiWidth     = m_ppcRecoYuvBest[uiDepth]->getWidth   ( );
-      UInt  uiHeight    = m_ppcRecoYuvBest[uiDepth]->getHeight  ( );
-      Pel*  piSrc       = m_ppcRecoYuvBest[uiDepth]->getLumaAddr( 0 );
-      UInt  uiSrcStride = m_ppcRecoYuvBest[uiDepth]->getStride  ( );
-      m_pcRdCost->setRenModelData( rpcBestCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
+    UInt  uiWidth     = m_ppcRecoYuvBest[uiDepth]->getWidth   ( );
+    UInt  uiHeight    = m_ppcRecoYuvBest[uiDepth]->getHeight  ( );
+    Pel*  piSrc       = m_ppcRecoYuvBest[uiDepth]->getLumaAddr( 0 );
+    UInt  uiSrcStride = m_ppcRecoYuvBest[uiDepth]->getStride  ( );
+    m_pcRdCost->setRenModelData( rpcBestCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
   }
 #endif
@@ -1608,6 +2051,12 @@
 #if HHI_MPI
     if( pcCU->getTextureModeDepth( uiAbsPartIdx ) == -1 || uiDepth < pcCU->getTextureModeDepth( uiAbsPartIdx ) )
-#endif
+    {
+#endif
+
     m_pcEntropyCoder->encodeSplitFlag( pcCU, uiAbsPartIdx, uiDepth );
+
+#if HHI_MPI
+    }
+#endif
   }
   else
@@ -1624,5 +2073,8 @@
 
     if( ( uiRPelX < pcSlice->getSPS()->getPicWidthInLumaSamples() ) && ( uiBPelY < pcSlice->getSPS()->getPicHeightInLumaSamples() ) )
+    {
       m_pcEntropyCoder->encodeSplitFlag( pcCU, uiAbsPartIdx, uiDepth );
+    }
+
     if( !pcCU->getSlice()->isIntra() )
     {
@@ -1631,6 +2083,8 @@
 #if FORCE_REF_VSP==1
       if( (pcCU->isSkipped( uiAbsPartIdx ) || pcCU->isVspMode( uiAbsPartIdx )) && pcCU->getSlice()->getViewId() != 0 )
-#if VSP_TEXT_ONLY
-      if( !pcCU->getSlice()->getSPS()->isDepth() )
+#if VSP_CFG
+      if( pcCU->getSlice()->getSPS()->getVspDepthPresentFlag() || !pcCU->getSlice()->getSPS()->isDepth() )
+#else
+      if( !pcCU->getSlice()->getVspDepthDisableFlag() || !pcCU->getSlice()->getSPS()->isDepth() )
 #endif
       {
@@ -1647,7 +2101,4 @@
       m_pcEntropyCoder->encodeMergeIndex( pcCU, uiAbsPartIdx, 0 );
       finishCU(pcCU,uiAbsPartIdx,uiDepth);
-#if DEBUGLOGOUT
-      m_cDebug.DebugLogOut( pcCU, uiAbsPartIdx, uiDepth );
-#endif
       xRestoreDepthWidthHeight( pcCU );
       return;
@@ -1694,4 +2145,5 @@
 #if HHI_MPI
   if( pcCU->getTextureModeDepth( uiAbsPartIdx ) == -1 )
+{
 #endif
   if( !pcCU->getSlice()->isIntra() )
@@ -1700,7 +2152,9 @@
 
 #if FORCE_REF_VSP==1
-    if( (pcCU->isSkipped( uiAbsPartIdx ) || pcCU->isVspMode( uiAbsPartIdx )) && pcCU->getSlice()->getViewId() != 0 )
-#if VSP_TEXT_ONLY
-    if( !pcCU->getSlice()->getSPS()->isDepth() )
+    if( (pcCU->isSkipped( uiAbsPartIdx ) || pcCU->isVspMode( uiAbsPartIdx )) && pcCU->getSlice()->getViewId() != 0 )]
+#if VSP_CFG
+    if( pcCU->getSlice()->getSPS()->getVspDepthPresentFlag() || !pcCU->getSlice()->getSPS()->isDepth() )
+#else
+    if( !pcCU->getSlice()->getVspDepthDisableFlag() || !pcCU->getSlice()->getSPS()->isDepth() )
 #endif
     {
@@ -1709,4 +2163,7 @@
 #endif
   }
+#if HHI_MPI
+}
+#endif
   
   if( pcCU->isSkipped( uiAbsPartIdx ) )
@@ -1715,4 +2172,11 @@
 #endif
   {
+#if OL_DEPTHLIMIT_A0044
+    if(pcCU->getPartDumpFlag())
+    {
+      pcCU->updatePartInfo(0,uiDepth);
+      pcCU->incrementPartInfo();
+    }
+#endif
     m_pcEntropyCoder->encodeMergeIndex( pcCU, uiAbsPartIdx, 0 );
 #if HHI_INTER_VIEW_RESIDUAL_PRED
@@ -1720,7 +2184,4 @@
 #endif
     finishCU(pcCU,uiAbsPartIdx,uiDepth);
-#if DEBUGLOGOUT
-    m_cDebug.DebugLogOut( pcCU, uiAbsPartIdx, uiDepth );
-#endif
     return;
   }
@@ -1730,7 +2191,4 @@
   {
     finishCU(pcCU,uiAbsPartIdx,uiDepth);
-#if DEBUGLOGOUT
-    m_cDebug.DebugLogOut( pcCU, uiAbsPartIdx, uiDepth );
-#endif
     return;
   }
@@ -1753,7 +2211,4 @@
       // Encode slice finish
       finishCU(pcCU,uiAbsPartIdx,uiDepth);
-#if DEBUGLOGOUT
-      m_cDebug.DebugLogOut( pcCU, uiAbsPartIdx, uiDepth );
-#endif
       return;
     }
@@ -1779,7 +2234,4 @@
   // --- write terminating bit ---
   finishCU(pcCU,uiAbsPartIdx,uiDepth);
-#if DEBUGLOGOUT
-  m_cDebug.DebugLogOut( pcCU, uiAbsPartIdx, uiDepth );
-#endif
 }
 
@@ -2613,6 +3065,9 @@
       }
 #if VSP_N
-#if !(!VSP_TEXT_ONLY && FORCE_REF_VSP==2)
-      else // inter
+#if VSP_CFG
+      else if( (!rpcTempCU->getSlice()->getSPS()->getVspDepthPresentFlag() && rpcTempCU->getSlice()->getViewId() ) || FORCE_REF_VSP!=2 ) // inter
+#else
+      else if( rpcTempCU->getSlice()->getVspDepthDisableFlag() || FORCE_REF_VSP!=2 ) // inter
+#endif
       {
         Int aiRefIdx[2] = {NOT_VALID, NOT_VALID};
@@ -2620,5 +3075,9 @@
         {
           aiRefIdx[iList] = pcTextureCU->getCUMvField( RefPicList(iList) )->getRefIdx( rpcTempCU->getZorderIdxInCU() + ui );
-          if( aiRefIdx[iList] >= 0 && pcTextureCU->getSlice()->getRefViewId( RefPicList(iList), aiRefIdx[iList] ) == NUM_VIEW_VSP )
+#if VSP_CFG
+          if( aiRefIdx[iList] >= rpcTempCU->getSlice()->getNumRefIdx( RefPicList(iList) ) )
+#else
+          if( aiRefIdx[iList] >= 0 && pcTextureCU->isVspRef( RefPicList(iList), aiRefIdx[iList] ) )
+#endif
           {
             return;
@@ -2630,5 +3089,4 @@
         //}
       }
-#endif
 #endif
     }
@@ -2830,6 +3288,8 @@
 #if FORCE_REF_VSP==1
   if( (pcCU->isSkipped( 0 ) || pcCU->isVspMode( 0 )) && pcCU->getSlice()->getViewId() != 0 )
-#if VSP_TEXT_ONLY
-  if( !pcCU->getSlice()->getSPS()->isDepth() )
+#if VSP_CFG
+  if( pcCU->getSlice()->getSPS()->getVspDepthPresentFlag() || !pcCU->getSlice()->getSPS()->isDepth() )
+#else
+  if( !pcCU->getSlice()->getVspDepthDisableFlag() || !pcCU->getSlice()->getSPS()->isDepth() )
 #endif
     m_pcEntropyCoder->encodeVspFlag ( pcCU, 0, true );
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncCu.h
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncCu.h	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncCu.h	(revision 193)
@@ -46,7 +46,4 @@
 #include "TLibCommon/TComBitCounter.h"
 #include "TLibCommon/TComDataCU.h"
-#if DEBUGLOGOUT
-#include "TLibCommon/DebugLog.h"
-#endif
 
 #include "TEncEntropy.h"
@@ -116,8 +113,4 @@
 
 public:
-#if DEBUGLOGOUT
-  DebugLog                m_cDebug;
-#endif
-
   /// copy parameters from encoder class
   Void  init                ( TEncTop* pcEncTop );
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncEntropy.cpp
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 193)
@@ -1370,5 +1370,5 @@
 #if VSP_MV_ZERO
           Int iRefIdx = pcCU->getCUMvField( RefPicList( uiRefListIdx ) )->getRefIdx(uiSubPartIdx);
-          if( !(pcCU->getSlice()->getViewId() && iRefIdx >= 0 && pcCU->getSlice()->getRefViewId( RefPicList( uiRefListIdx ), iRefIdx ) == NUM_VIEW_VSP) )
+          if( !(pcCU->getSlice()->getViewId() && iRefIdx >= 0 && pcCU->isVspRef( RefPicList( uiRefListIdx ), iRefIdx )) )
           {
 #endif
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncGOP.cpp
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 193)
@@ -332,15 +332,45 @@
 #endif
 
+#if VSP_SLICE_HEADER && VSP_CFG
+      pcSlice->setNumVspRefPics( m_pcCfg->getGOPEntry( (getNalUnitType(uiPOCCurr) == NAL_UNIT_CODED_SLICE_IDV) ? MAX_GOP : iGOPid ).m_numVSPRefPics );
+      pcSlice->setVspFlag( m_pcEncTop->getUseVSP() && pcSlice->getNumVspRefPics() > 0 );
+      for( UInt i = 0; i < pcSlice->getNumVspRefPics(); i++ )
+      {
+        pcSlice->setVspRefPos( REF_PIC_LIST_0, i, m_pcCfg->getGOPEntry( (getNalUnitType(uiPOCCurr) == NAL_UNIT_CODED_SLICE_IDV) ? MAX_GOP : iGOPid ).m_VSPRefPosL0[i] );
+        if( pcSlice->getSliceType() == B_SLICE )
+        {
+          pcSlice->setVspRefPos( REF_PIC_LIST_1, i, m_pcCfg->getGOPEntry( (getNalUnitType(uiPOCCurr) == NAL_UNIT_CODED_SLICE_IDV) ? MAX_GOP : iGOPid ).m_VSPRefPosL1[i] );
+        }
+      }
+#endif
+
 #if VSP_N
+#if VSP_CFG
+      Int NumberOfVspRefsL0 = ( ( pcPic->getViewId()==0
+                                || (m_pcEncTop->getVSPDepthDisable() && m_pcEncTop->getIsDepth())
+#if VSP_SLICE_HEADER
+                                || !pcSlice->getVspFlag()
+#endif
+                                || pcSlice->getVspRefPos( REF_PIC_LIST_0, 0 ) == 0
+                              ) ? 0 : 1 );
+      Int NumberOfVspRefsL1 = ( ( pcPic->getViewId()==0
+                                || (m_pcEncTop->getVSPDepthDisable() && m_pcEncTop->getIsDepth())
+#if VSP_SLICE_HEADER
+                                || !pcSlice->getVspFlag()
+#endif
+                                || pcSlice->getVspRefPos( REF_PIC_LIST_1, 0 ) == 0
+                              ) ? 0 : 1 );
+      pcSlice->setNumRefIdx( REF_PIC_LIST_0, min( m_pcCfg->getGOPEntry( (getNalUnitType(uiPOCCurr) == NAL_UNIT_CODED_SLICE_IDV) ? MAX_GOP : iGOPid ).m_numRefPicsActive + NumberOfVspRefsL0, (pcSlice->getRPS()->getNumberOfPictures() + pcSlice->getSPS()->getNumberOfUsableInterViewRefs() + NumberOfVspRefsL0) ) );
+      pcSlice->setNumRefIdx( REF_PIC_LIST_1, min( m_pcCfg->getGOPEntry( (getNalUnitType(uiPOCCurr) == NAL_UNIT_CODED_SLICE_IDV) ? MAX_GOP : iGOPid ).m_numRefPicsActive + NumberOfVspRefsL1, (pcSlice->getRPS()->getNumberOfPictures() + pcSlice->getSPS()->getNumberOfUsableInterViewRefs() + NumberOfVspRefsL1) ) );
+#else
       Int NumberOfVspRefs = ( ( pcPic->getViewId()==0
-#if VSP_TEXT_ONLY
-                                || m_pcEncTop->getIsDepth()
-#endif
+                                || (m_pcEncTop->getVSPDepthDisable() && m_pcEncTop->getIsDepth())
 #if VSP_SLICE_HEADER
-                                || !m_pcEncTop->getUseVSP()
+                                || !pcSlice->getVspFlag()
 #endif
                               ) ? 0 : 1 );
       pcSlice->setNumRefIdx( REF_PIC_LIST_0, min( m_pcCfg->getGOPEntry( (getNalUnitType(uiPOCCurr) == NAL_UNIT_CODED_SLICE_IDV) ? MAX_GOP : iGOPid ).m_numRefPicsActive + NumberOfVspRefs, (pcSlice->getRPS()->getNumberOfPictures() + pcSlice->getSPS()->getNumberOfUsableInterViewRefs() + NumberOfVspRefs) ) );
       pcSlice->setNumRefIdx( REF_PIC_LIST_1, min( m_pcCfg->getGOPEntry( (getNalUnitType(uiPOCCurr) == NAL_UNIT_CODED_SLICE_IDV) ? MAX_GOP : iGOPid ).m_numRefPicsActive + NumberOfVspRefs, (pcSlice->getRPS()->getNumberOfPictures() + pcSlice->getSPS()->getNumberOfUsableInterViewRefs() + NumberOfVspRefs) ) );
+#endif
 #else
       pcSlice->setNumRefIdx( REF_PIC_LIST_0, min( m_pcCfg->getGOPEntry( (getNalUnitType(uiPOCCurr) == NAL_UNIT_CODED_SLICE_IDV) ? MAX_GOP : iGOPid ).m_numRefPicsActive, (pcSlice->getRPS()->getNumberOfPictures() + pcSlice->getSPS()->getNumberOfUsableInterViewRefs()) ) );
@@ -373,16 +403,31 @@
 #if VSP_N
       Bool bUseVsp = (pcPic->getViewId()!=0);
-#if VSP_TEXT_ONLY
-      if( m_pcEncTop->getIsDepth() ) bUseVsp = false;
-#endif
+      if( m_pcEncTop->getVSPDepthDisable() && m_pcEncTop->getIsDepth() ) bUseVsp = false;
 #if VSP_SLICE_HEADER
+#if VSP_CFG
+      if( !pcSlice->getVspFlag() ) bUseVsp = false;
+#else
       if( !m_pcEncTop->getUseVSP() ) bUseVsp = false;
 #endif
+#endif
+
+#if VSP_SLICE_HEADER
+      if( bUseVsp )
+#endif
+      {
+        m_pcEncTop->getVSPBuf()->getCurrSlice()->setPOC( pcPic->getPOC() );
+        m_pcEncTop->getVSPBuf()->getCurrSlice()->setViewId( pcPic->getViewId() );
+      }
+
       pcSlice->setRefPicListMvc( rcListPic, apcInterViewRefPics, bUseVsp ? m_pcEncTop->getVSPBuf() : NULL );
 #else
       pcSlice->setRefPicListMvc( rcListPic, apcInterViewRefPics );
 #endif
+
+#if !VSP_CFG
 #if VSP_SLICE_HEADER
-      pcSlice->setVspFlag( bUseVsp );
+      pcSlice->setVspFlag( m_pcEncTop->getUseVSP() );
+      pcSlice->setVspDepthDisableFlag( m_pcEncTop->getVSPDepthDisable() );
+#endif
 #endif
 
@@ -471,4 +516,5 @@
     Int iVSOMode = m_pcEncTop->getVSOMode();
     m_pcRdCost->setVSOMode( iVSOMode  );
+
 #if HHI_VSO_DIST_INT
     m_pcRdCost->setAllowNegDist( m_pcEncTop->getAllowNegDist() );
@@ -491,5 +537,8 @@
     m_pcRdCost->setDepthPicYuv   ( m_pcEncTop->getEncTop()->getPicYuvFromView( pcSlice->getViewId(), pcSlice->getPOC(), true, false ) );
 #endif
-
+#if LGE_WVSO_A0119
+    Bool bUseWVSO  = m_pcEncTop->getUseWVSO();
+    m_pcRdCost->setUseWVSO( bUseWVSO );
+#endif
 
   }
@@ -1157,24 +1206,26 @@
           m_pcSbacCoder->load( &pcSbacCoders[0] );
 
-#if DEBUGLOGOUT
-        char fname[128];
-        sprintf(fname, "%sV%02d_%05d%s.csv", "Log", pcSlice->getViewId(), uiPOCCurr, pcSlice->getIsDepth() ? "depth":"text");
-        getSliceEncoder()->getCUEncoder()->m_cDebug.DebugLogFileOpen( fname );
-#endif
-
         pcSlice->setTileOffstForMultES( uiOneBitstreamPerSliceLength );
         if (!bEntropySlice)
         {
+#if OL_DEPTHLIMIT_A0044 //start dumping partition information
+          m_pcSliceEncoder->setPartDumpFlag(1);
+#endif
           pcSlice->setTileLocationCount ( 0 );
           m_pcSliceEncoder->encodeSlice(pcPic, pcBitstreamRedirect, pcSubstreamsOut); // redirect is only used for CAVLC tile position info.
+#if OL_DEPTHLIMIT_A0044 //stop dumping partition information
+          m_pcSliceEncoder->setPartDumpFlag(0);
+#endif
         }
         else
         {
+#if OL_DEPTHLIMIT_A0044 //start dumping partition information
+          m_pcSliceEncoder->setPartDumpFlag(1);
+#endif
           m_pcSliceEncoder->encodeSlice(pcPic, &nalu.m_Bitstream, pcSubstreamsOut); // nalu.m_Bitstream is only used for CAVLC tile position info.
-        }
-
-#if DEBUGLOGOUT
-        getSliceEncoder()->getCUEncoder()->m_cDebug.DebugLogFileClose();
-#endif
+#if OL_DEPTHLIMIT_A0044 //stop dumping partition information
+          m_pcSliceEncoder->setPartDumpFlag(0);
+#endif
+        }
 
         {
@@ -2187,4 +2238,11 @@
         printf( "V%d ", pcSlice->getRefViewId( RefPicList(iRefList), iRefIndex ) );
       }
+#if VSP_CFG
+      else if( pcSlice->getViewId() == pcSlice->getRefViewId( RefPicList(iRefList), iRefIndex )
+            && pcSlice->getPOC()    == pcSlice->getRefPOC( RefPicList(iRefList), iRefIndex ) )
+      {
+        printf( "VS " );
+      }
+#endif
       else
       {
@@ -2203,4 +2261,11 @@
         printf( "V%d ", pcSlice->getRefViewId( (RefPicList)pcSlice->getListIdFromIdxOfLC(iRefIndex), pcSlice->getRefIdxFromIdxOfLC(iRefIndex) ) );
       }
+#if VSP_CFG
+      else if( pcSlice->getViewId() == pcSlice->getRefViewId( (RefPicList)pcSlice->getListIdFromIdxOfLC(iRefIndex), pcSlice->getRefIdxFromIdxOfLC(iRefIndex) )
+            && pcSlice->getPOC()    == pcSlice->getRefPOC( (RefPicList)pcSlice->getListIdFromIdxOfLC(iRefIndex), pcSlice->getRefIdxFromIdxOfLC(iRefIndex) ) )
+      {
+        printf( "VS " );
+      }
+#endif
       else
       {
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncSbac.cpp
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 193)
@@ -580,4 +580,7 @@
 {
   PartSize eSize         = pcCU->getPartitionSize( uiAbsPartIdx );
+#if OL_DEPTHLIMIT_A0044
+  UInt uiSymbol;
+#endif
   if ( pcCU->isIntra( uiAbsPartIdx ) )
   {
@@ -585,5 +588,20 @@
     {
       m_pcBinIf->encodeBin( eSize == SIZE_2Nx2N? 1 : 0, m_cCUPartSizeSCModel.get( 0, 0, 0 ) );
-    }
+#if OL_DEPTHLIMIT_A0044
+      if(pcCU->getPartDumpFlag())
+      {
+        uiSymbol = (UInt)(eSize == SIZE_2Nx2N? 1 : 0);
+        pcCU->updatePartInfo(uiSymbol?0:1,uiDepth); //0 for 2Nx2N and 1 for NxN
+        pcCU->incrementPartInfo();
+      }
+#endif
+    }
+#if OL_DEPTHLIMIT_A0044
+    if(pcCU->getPartDumpFlag() && uiDepth < g_uiMaxCUDepth - g_uiAddCUDepth && !pcCU->getSlice()->isIntra())
+    {
+      pcCU->updatePartInfo(0,uiDepth); //0 for 2Nx2N and 1 for NxN
+      pcCU->incrementPartInfo();
+    }
+#endif
     return;
   }
@@ -591,12 +609,19 @@
   switch(eSize)
   {
-    case SIZE_2Nx2N:
+  case SIZE_2Nx2N:
     {
       m_pcBinIf->encodeBin( 1, m_cCUPartSizeSCModel.get( 0, 0, 0) );
+#if OL_DEPTHLIMIT_A0044
+      if(pcCU->getPartDumpFlag())
+      {
+        pcCU->updatePartInfo(0,uiDepth); //0 for 2Nx2N
+        pcCU->incrementPartInfo();
+      }
+#endif
       break;
     }
-    case SIZE_2NxN:
-    case SIZE_2NxnU:
-    case SIZE_2NxnD:
+  case SIZE_2NxN:
+  case SIZE_2NxnU:
+  case SIZE_2NxnD:
     {
       m_pcBinIf->encodeBin( 0, m_cCUPartSizeSCModel.get( 0, 0, 0) );
@@ -623,9 +648,16 @@
         }
       }
+#if OL_DEPTHLIMIT_A0044
+      if(pcCU->getPartDumpFlag())
+      {
+        pcCU->updatePartInfo(2,uiDepth); //2 for 2NxN
+        pcCU->incrementPartInfo();
+      }
+#endif
       break;
     }
-    case SIZE_Nx2N:
-    case SIZE_nLx2N:
-    case SIZE_nRx2N:
+  case SIZE_Nx2N:
+  case SIZE_nLx2N:
+  case SIZE_nRx2N:
     {
       m_pcBinIf->encodeBin( 0, m_cCUPartSizeSCModel.get( 0, 0, 0) );
@@ -656,7 +688,14 @@
         }
       }
+#if OL_DEPTHLIMIT_A0044
+      if(pcCU->getPartDumpFlag())
+      {
+        pcCU->updatePartInfo(3,uiDepth); //3 for Nx2N
+        pcCU->incrementPartInfo();
+      }
+#endif
       break;
     }
-    case SIZE_NxN:
+  case SIZE_NxN:
     {
       if( uiDepth == g_uiMaxCUDepth - g_uiAddCUDepth && !( pcCU->getSlice()->getSPS()->getDisInter4x4() && pcCU->getWidth(uiAbsPartIdx) == 8 && pcCU->getHeight(uiAbsPartIdx) == 8 ) )
@@ -665,8 +704,25 @@
         m_pcBinIf->encodeBin( 0, m_cCUPartSizeSCModel.get( 0, 0, 1) );
         m_pcBinIf->encodeBin( 0, m_cCUPartSizeSCModel.get( 0, 0, 2) );
+#if OL_DEPTHLIMIT_A0044
+        if(pcCU->getPartDumpFlag())
+        {
+          pcCU->updatePartInfo(1,uiDepth); //2Nx2N here since we disable NxN in Inter
+          pcCU->incrementPartInfo();         
+        }
+#endif
+      }
+      else
+      {
+#if OL_DEPTHLIMIT_A0044
+        if(pcCU->getPartDumpFlag())
+        {
+          pcCU->updatePartInfo(0,uiDepth); //2Nx2N here since we disable NxN in Inter
+          pcCU->incrementPartInfo();
+        }
+#endif
       }
       break;
     }
-    default:
+  default:
     {
       assert(0);
@@ -785,13 +841,20 @@
   uiNumCand = pcCU->getSlice()->getMaxNumMergeCand();
 #if HHI_MPI
-#if VSP_TEXT_ONLY
+#if VSP_N
   TComDataCU* pcTextCU = pcCU->getSlice()->getSPS()->getUseMVI() ? pcCU->getSlice()->getTexturePic()->getCU( pcCU->getAddr() ) : NULL;
   Int aiRefIdxVsp[2] = { pcTextCU ? pcTextCU->getCUMvField( RefPicList(0) )->getRefIdx( uiAbsPartIdx ) : -1,
                          pcTextCU ? pcTextCU->getCUMvField( RefPicList(1) )->getRefIdx( uiAbsPartIdx ) : -1 };
-  const Bool bMVIAvailable = pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE
-    && !( aiRefIdxVsp[0] >= 0 && pcTextCU->getSlice()->getRefViewId( RefPicList(0), aiRefIdxVsp[0] ) == NUM_VIEW_VSP )
-    && !( aiRefIdxVsp[1] >= 0 && pcTextCU->getSlice()->getRefViewId( RefPicList(1), aiRefIdxVsp[1] ) == NUM_VIEW_VSP );
-#else
-  const Bool bMVIAvailable = pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE;
+#if VSP_CFG
+  const Bool bMVIAvailable = (pcCU->getSlice()->getSPS()->getVspDepthPresentFlag() || pcCU->getSlice()->getViewId()==0) 
+                                ? pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE
+                                : pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE
+                                  && !( aiRefIdxVsp[0] >= pcCU->getSlice()->getNumRefIdx( RefPicList(0) ) )
+                                  && !( aiRefIdxVsp[1] >= pcCU->getSlice()->getNumRefIdx( RefPicList(1) ) );
+#else
+  const Bool bMVIAvailable = pcCU->getSlice()->getVspDepthDisableFlag() ? pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE
+                                                                          && !( aiRefIdxVsp[0] >= 0 && pcTextCU->isVspRef( RefPicList(0), aiRefIdxVsp[0] ) )
+                                                                          && !( aiRefIdxVsp[1] >= 0 && pcTextCU->isVspRef( RefPicList(1), aiRefIdxVsp[1] ) )
+                                                                        : pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE;
+#endif
 #endif
   if( bMVIAvailable )
@@ -858,4 +921,14 @@
   assert( uiCtx < 3 );
   m_pcBinIf->encodeBin( uiCurrSplitFlag, m_cCUSplitFlagSCModel.get( 0, 0, uiCtx ) );
+#if OL_DEPTHLIMIT_A0044
+  if(pcCU->getPartDumpFlag())
+  {
+    if(pcCU->getSlice()->isIntra() || (!pcCU->getSlice()->isIntra() && uiCurrSplitFlag!=0))
+    {
+      pcCU->updatePartInfo(uiCurrSplitFlag,uiDepth);
+      pcCU->incrementPartInfo();
+    }
+  }
+#endif
   DTRACE_CABAC_VL( g_nSymbolCounter++ )
   DTRACE_CABAC_T( "\tSplitFlag\n" )
